Subject: Re: [PATCH] bc47xx : fix ssb irq setup

From: Michael Buesch <[email-masked]>
Date: Tue, 19 May 2009 15:19:58 +0200

On Tuesday 19 May 2009 00:06:12 matthieu castet wrote:
> Hi,
> 
> the current ssb irq setup (in ssb_mipscore_init) have some problem :
> it configure some device on some irq without checking that the irq is 
> not taken by an other device.
> 
> For example in my case PCI host is on irq 0 and IPSEC on irq 3.
> The current code :
> - store in dev->irq that IPSEC irq is 3+2
> - do a set_irq 0->3 on PCI host
> 
> But now IPSEC irq is not routed anymore to the mips code and dev->irq is 
> wrong. This cause problem described in [1].
> 
> This patch try to solve the problem by making set_irq configure the 
> device we want to take the irq on the shared irq0.
> The previous example become :
> - store in dev->irq that IPSEC irq is 3+2
> - do a set_irq 0->3 on PCI host :
>    - irq 3 is already taken by IPSEC. do a set_irq 3->0 on IPSEC
> 
> 
> I also added some code to print the irq configuration before and after 
> irq setup to allow easier debugging. And I add extra checking in 
> ssb_mips_irq to report device without irq or device with not routed irq.
> 
> 
> [1] http://www.danm.de/files/src/bcm5365p/REPORTED_DEVICES
> 
> Signed-off-by: Matthieu CASTET <[email-masked]>
> 

If this works on all devices, I'm OK with this. Please submit to [email-masked]
You can add my ack.

-- 
Greetings, Michael.